From beceb09e2292ab716ca08715ebe1adb2795d1099 Mon Sep 17 00:00:00 2001
From: Sucheta Chakraborty <sucheta.chakraborty@qlogic.com>
Date: Tue, 20 Sep 2011 03:31:34 -0700
Subject: [PATCH] ethtool: add support for external loopback.

External loopback will be performed in addition to other offline tests.
User need to pass new parameter "external_lb" for the same.

Reqd. man page changes included.

Signed-off-by: Sucheta Chakraborty <sucheta.chakraborty@qlogic.com>
[bwh: Report whether the external loopback test 'was', not 'is'
 executed.  For compatibility, don't report this if not requested.]
Signed-off-by: Ben Hutchings <bhutchings@solarflare.com>
Acked-by: David Chang <dchang@suse.com>
---
 ethtool.8.in |   15 +++++++++++----
 ethtool.c    |   14 ++++++++++++--
 2 files changed, 23 insertions(+), 6 deletions(-)

Index: ethtool-2.6.39/ethtool.8.in
===================================================================
--- ethtool-2.6.39.orig/ethtool.8.in
+++ ethtool-2.6.39/ethtool.8.in
@@ -68,6 +68,10 @@
 .\"
 .ds HO \fBm\fP|\fBv\fP|\fBt\fP|\fBs\fP|\fBd\fP|\fBf\fP|\fBn\fP|\fBr\fP...
 .\"
+.\"	\(*SD - Self-diag test values
+.\"
+.ds SD \fBoffline\fP|\fBonline\fP|\fBexternal_lb\fP
+.\"
 .\"	\(*NC - Network Classifier type values
 .\"
 .ds NC \fBether\fP|\fBip4\fP|\fBtcp4\fP|\fBudp4\fP|\fBsctp4\fP|\fBah4\fP|\fBesp4\fP
@@ -227,7 +231,7 @@ ethtool \- query or control network driv
 .HP
 .B ethtool \-t|\-\-test
 .I ethX
-.B1 offline online
+.RI [\*(SD]
 .HP
 .B ethtool \-s
 .I ethX
@@ -466,12 +470,14 @@ statistics.
 .B \-t \-\-test
 Executes adapter selftest on the specified network device. Possible test modes are:
 .TP
-.A1 offline online
+.RI \*(SD
 defines test type: 
 .B offline
 (default) means to perform full set of tests possibly causing normal operation interruption during the tests,
 .B online
-means to perform limited set of tests do not interrupting normal adapter operation.
+means to perform limited set of tests do not interrupting normal adapter operation,
+.B external_lb
+means to perform external-loopback test in addition to other offline tests.
 .TP
 .B \-s \-\-change
 Allows changing some or all settings of the specified network device.
@@ -784,7 +790,8 @@ Andre Majorel,
 Eli Kupermann,
 Scott Feldman,
 Andi Kleen,
-Alexander Duyck.
+Alexander Duyck,
+Sucheta Chakraborty.
 .SH AVAILABILITY
 .B ethtool
 is available from
Index: ethtool-2.6.39/ethtool.c
===================================================================
--- ethtool-2.6.39.orig/ethtool.c
+++ ethtool-2.6.39/ethtool.c
@@ -223,7 +223,7 @@ static struct option {
     { "-p", "--identify", MODE_PHYS_ID, "Show visible port identification (e.g. blinking)",
                 "               [ TIME-IN-SECONDS ]\n" },
     { "-t", "--test", MODE_TEST, "Execute adapter self test",
-                "               [ online | offline ]\n" },
+		"               [ online | offline | external_lb ]\n" },
     { "-S", "--statistics", MODE_GSTATS, "Show adapter statistics" },
     { "-n", "--show-nfc", MODE_GNFC, "Show Rx network flow classification "
 		"options",
@@ -424,6 +424,7 @@ static struct ethtool_rx_flow_spec rx_ru
 static enum {
 	ONLINE=0,
 	OFFLINE,
+	EXTERNAL_LB,
 } test_type = OFFLINE;
 
 typedef enum {
@@ -829,6 +830,8 @@ static void parse_cmdline(int argc, char
 					test_type = ONLINE;
 				} else if (!strcmp(argp[i], "offline")) {
 					test_type = OFFLINE;
+				} else if (!strcmp(argp[i], "external_lb")) {
+					test_type = EXTERNAL_LB;
 				} else {
 					exit_bad_args();
 				}
@@ -1768,6 +1771,11 @@ static int dump_test(struct ethtool_drvi
 	rc = test->flags & ETH_TEST_FL_FAILED;
 	fprintf(stdout, "The test result is %s\n", rc ? "FAIL" : "PASS");
 
+	if (test_type == EXTERNAL_LB)
+		fprintf(stdout, "External loopback test was %sexecuted\n",
+			(test->flags & ETH_TEST_FL_EXTERNAL_LB_DONE) ?
+			"" : "not ");
+
 	if (info->testinfo_len)
 		fprintf(stdout, "The test extra info:\n");
 
@@ -2911,7 +2919,9 @@ static int do_test(int fd, struct ifreq
 	memset (test->data, 0, drvinfo.testinfo_len * sizeof(u64));
 	test->cmd = ETHTOOL_TEST;
 	test->len = drvinfo.testinfo_len;
-	if (test_type == OFFLINE)
+	if (test_type == EXTERNAL_LB)
+		test->flags = (ETH_TEST_FL_OFFLINE | ETH_TEST_FL_EXTERNAL_LB);
+	else if (test_type == OFFLINE)
 		test->flags = ETH_TEST_FL_OFFLINE;
 	else
 		test->flags = 0;
